﻿unit Unit2;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Generics.Collections, AdvCustomControl, AdvTreeViewBase, AdvTreeViewData, AdvCustomTreeView, AdvTreeView, Unit1, AdvCheckedTreeView, Vcl.StdCtrls, Vcl.ExtCtrls;

type

  TForm2 = class(TForm)
    AdvCheckedTreeView: TAdvCheckedTreeView;
    Panel1: TPanel;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure AdvCheckedTreeViewBeforeUpdateNode(Sender: TObject; ANode: TAdvTreeViewVirtualNode; AColumn: Integer; var AText: string; var ACanUpdate: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
    FooList: TObjectList<TFoo>;
    procedure FillTreeView;
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

procedure TForm2.AdvCheckedTreeViewBeforeUpdateNode(Sender: TObject; ANode: TAdvTreeViewVirtualNode; AColumn: Integer; var AText: string; var ACanUpdate: Boolean);
begin
  TFoo(ANode.Node.DataObject).Name := Trim(AText);
end;

procedure TForm2.Button1Click(Sender: TObject);
begin
  AdvCheckedTreeView.EditNode(AdvCheckedTreeView.SelectedNode, 0);
end;

procedure TForm2.FillTreeView;
var
	t: TAdvCheckedTreeView;
  n: TAdvTreeViewNode;
  i: Integer;
begin

	t := AdvCheckedTreeView;

  //-- Start the UPdate
  t.BeginUpdate;

  //-- Clear
  t.ClearNodes;
  t.ClearColumns;

	//-- Set Properties
  t.Align := alClient;
  t.Margins.Left := 5;
  t.Margins.Right := 5;
  t.Margins.Top := 5;
  t.Margins.Bottom := 5;
  t.AlignWithMargins := True;

  t.NodesAppearance.ShowFocus := False;
  t.NodesAppearance.ShowLines := False;
  t.NodesAppearance.SelectionArea := tsaFull;

  t.ColumnsAppearance.Layouts := [];
  t.ColumnsAppearance.StretchColumn := 0;
  t.ColumnsAppearance.StretchAll := false;
  t.ColumnsAppearance.Stretch := true;

  t.Interaction.TouchScrolling := False;
  t.Interaction.DragDropMode := tdmNone;
  t.Interaction.Reorder := True;

  //-- Add Single Column
  t.Columns.Add.Text := 'Column 1';
  t.Columns[0].EditorType := tcetEdit;

  for i := 0 to FooList.Count - 1 do
	begin
    n := t.Nodes.Add;
    n.Extended := False;
    n.Text[0] := 'Data To Include';
    n.CheckTypes[0] := TAdvTreeViewNodeCheckType.tvntCheckBox;
    n.Checked[0] := FooList[i].Visible;
    n.DataObject := FooList[i];
  	n.Text[0] := FooList[i].Name;
  end;

  //-- End Update
  t.EndUpdate;

  t.ExpandAll;

  t.SelectedNode := t.Nodes.Items[0];
end;

procedure TForm2.FormCreate(Sender: TObject);
begin

  FooList := TObjectList<TFoo>.Create(True);

  FooList.Add(TFoo.Create('Alpha'));
  FooList.Add(TFoo.Create('Beta'));
  FooList.Add(TFoo.Create('Gamma'));
  FooList.Add(TFoo.Create('Delta'));
  FooList.Add(TFoo.Create('Epsilon'));
  FooList.Add(TFoo.Create('Rho'));
  FooList.Add(TFoo.Create('Theta'));

  FillTreeView;
end;

procedure TForm2.FormDestroy(Sender: TObject);
begin
  FooList.Free;
end;

end.
